Title: Programming Raspberry PI using Simulink (#MatlabXXX)
Date: 2016-07-09 
Modified: 2016-03-24 
Category: Electronics
Tags: Raspberry Pi, Simulink, Matlab, Ultrasonic, HT-SR04
Slug: MW_RPI1
Authors: Jose Vicente



 
<style type="text/css">
  .centeredImage
    {
    text-align:center;
    margin-top:0px;
    margin-bottom:0px;
    padding:0px;
    }
</style>



Introduction
------------

It seems to be Matworks has realized that there is an interesting market on the low cost hardware devices with  hobbyist and DIY enthusiasts  around the world. Several years ago they've  started adding support to some microcontrollers as the Microchip DsPIC series using platform dedicated  blocksets in Simulink. ( On this topic ,  I've uploaded a Youtube video  about 2 years ago XXXXXXX  link here). They then continued adding similar support on much  more popular platforms like Arduino which I've believe they started since 2012 or so. They then continued with more hardware including Android devices and the Raspberry Pi.  Recently, they even released a low cost Matlab version for individuals similar to the student version . Kudos for Mathworks  as there is a lot of people willing to "play" with Matlab but cannot afford the thousand of dollars on a licensee that it is actually intended for corporations. I believe Autodesk is having similar approach aiming to individuals and makers with free or very low cost options.

<!-- PELICAN_BEGIN_SUMMARY -->
 I have several Raspberry pi boards at my home for different applications running Raspbian, Archlinux, and OpenElect   so i've decided to  experiment Matlab with one of them and downloaded and installed the support package for RPI model B+ .  
<!-- PELICAN_END_SUMMARY -->
This process also involves flashing a microSD card with a Matalab configured Raspbian OS. Then,  booting the RPI with this card will automatically autologin and  start the windows manager Once up and running ,  the  RPI will communicate with the windows machine running Matlab.  Depending which option you install the support package, the RPI can be connected point to point using an Ethernet cable or it can be configured sharing the same subnet as the windows machine running  Matlab  foe example on a home network.

As a proof of concept demo, I decided to use a popular  Ultrasonic module , Below figure shows the model concept ,



<br>
<p class="centeredImage">  <img src="/images/RPSIMUfih1928_750.jpg" alt="Picture of assy " height="600" width="450 align="middle" ></p>
<p class="centeredImage" >  <b>RPI with Ultrasonic Module </b></p>
<br>


Next figure shows the wiring of the HT-SR04  and RPI GPIO pins.


<br>
<p class="centeredImage">  <img src="/images/RPSIMUfih2986_708.jpg" alt="Picture of assy " height="500" width="404" align="middle" ></p>
<p class="centeredImage" >  <b>RPI with HC-SR04  </b></p>
<br>

Then , it is a matter of creating a Simulink model and start adding and interconnecting blocksets.
The complete example is shown in this [video][yout1].
The model file along with the Python code for the UDPreceiver display can be downloaded [here][codep].


[yout1]: https://youtu.be/i4zwhtYzIIk 
[codep]: /files/Sim_RPI_1.zip

<br>
<p class="centeredImage">  <img src="/images/RPSIMUfih3_1000_609.jpg" alt="Picture of assy " height="500" width="404" align="middle" ></p>
<p class="centeredImage" >  <b>  Raspberry Pi with all wiring </b></p>
<br>












It is very convenient the use of Simulink blocks in a completely graphical environment 









Most electronic applications require light indication of some sort not to mention the trivial power ON lamp.
As  single color lamp can bear two states of information. Several small embedded applications, apart from the ON/OFF states  used to produce  different blinking patterns in order to convey more information to the user. 
The RGB LEDs are multiplying the information that a single source of light can produce (which can also be increased using blinking patterns). 


Application
-----------

<!--Place picture using centered image style class-->

<br>
<p class="centeredImage">  <img src="/images/schematic1.png" alt="LEDS on Flex PCB " height="500" width="400" align="middle" ></p>
<p class="centeredImage" >  <b>Basic LPD8806 Schematic </b></p>
<br>



<!--Links are as follows  between brackets the word to have the link , then a keyword on the side , then-->
<!--later on the same keyword with colon and the link or file folder-->


As there is not official  information on the communication protocol (the only availbale and poorly translated [datasheet] [d_sheet] ),

[d_sheet]: /files/lpd8806-dataheet.pdf

from [Github][LPD_AVR].

[LPD_AVR]: https://github.com/Jofre1/LPD8806-AVR



<!--Video insertion-->


{% video /video/LPD8806.mp4 100 50 /images/LPD8806_First_Frame.png %}
<!--You tube video-->

<a href="http://www.youtube.com/watch?feature=player_embedded&v=YOUTUBE_VIDEO_ID_HERE
" target="_blank"><img src="http://img.youtube.com/vi/YOUTUBE_VIDEO_ID_HERE/0.jpg" 
alt="IMAGE ALT TEXT HERE" width="240" height="180" border="10" /></a>

<!--Or pure Markdown but losing the image sizing and border: -->

[![IMAGE ALT TEXT HERE](http://img.youtube.com/vi/YOUTUBE_VIDEO_ID_HERE/0.jpg)](http://www.youtube.com/watch?v=YOUTUBE_VIDEO_ID_HERE)

